#ifndef _CONFIG_H
#define _CONFIG_H

class Config {

public:

	Config();
	~Config();

	void loadConfig();

	int getPlayerMax();
	int getBackupInterval();
	char *getName();
	char *getMotd();
	char *getPort();
	bool getPublic();
	bool getVerify();

	struct User *getUserList();
	struct Banned *getBannedList();

private:

	void writeConfig();

	int parseConfig();
	void parseUserList();
	void parseBannedList();

	int playerMax;
	int backupInterval;
	
	char cfgName[64];
	char cfgMotd[64];
	char cfgPort[6];
	
	bool cfgPublic;
	bool cfgVerify;
	bool cfgPhysWater;
	bool cfgPhysLava;

	struct User *userList;
	struct Banned *bannedList;

};

#endif
