#ifndef DEFINES_H
#define DEFINES_H

#if WIN_32
#include <winsock2.h>
#else
#include <netinet/in.h>
#include <sys/types.h>
#include <arpa/inet.h>
#include <netdb.h>
#endif

/* PLAYER STRUCT */
struct Player {
	unsigned int sock;

	char playerName[32];
	int namelen;

	unsigned char id_byte;
	unsigned char userlevel;
	unsigned char id_privsay;

	bool setblock;
	char block;

	bool drawing;
	unsigned short drawFrom[3];
	unsigned short drawTo[3];

	bool isoperator;
	bool hidden;
    bool painting;

	unsigned short posx, posy, posz;
	unsigned char rotx, roty;

	struct sockaddr_in clientinfo;
};

struct User {
	char name[32];
	unsigned char level;
	struct User *next;
};

struct Banned {
	char name[32];
	char ip[16];
	struct Banned *next;
};

#define OUR_HEADERLEN 17

#define PACKLEN_BLOCK 9
#define PACKLEN_MOVE 10
#define PACKLEN_KICK 65
#define PACKLEN_CHAT 66
#define PACKLEN_SPAWN 74
#define PACKLEN_SRVINFO 131
#define PACKLEN_MAP 1028

#endif
